<?php

require_once 'admin-header.php';
echo $html_header;


$self = 'index.php';

switch ($_REQUEST['op']) {








    case 'clear-cache' : { //!
    // 2004-04-30 20:05:47

        echo '<h2>Publish</h2>';

        $_arr = array(); // the file listing array
        $handle = @opendir('../'.$path_temp);
        if (!$handle) {
            exit('The path <strong>'.$path.'</strong> is invalid.');
        }
        while ($file = readdir($handle)) {
            if($file != '.' && $file != '..') {
                $_arr[count($_arr)] = $file;
            }
        }
        closedir($handle);
        for ($i=0; $i < count($_arr); $i++) {
            $_arr[$i] = $path.$_arr[$i];
        }
        rsort($_arr, SORT_STRING);
        //print_r($_arr);

        foreach ($_arr as $file) {
            unlink('../'.$path_temp.$file);
        }
        echo '<p>The cache has been cleared.</p>';

        echo '<p>This app doesn&#8217;t actually &#8220;publish&#8221; files,
        it instead clears the cache of files produced as pages are viewed.
        If you change any album or photo details, or update a template, you
        must publish to reflect the changes.</p>';

        break;
    }






    case 'delete-album' : { //!


        echo '<h2>Delete Album</h2>';

        if (isset($_REQUEST['confirm'])) {

            if ( isset($_GET['id']) ) {

                // delete album from album db
                $db->open('../'.$path_db.$db_albums, 1);
                $res = $db->select('id', $_GET['id']);
                $check = $db->delete('id', $_GET['id']);
                $db->close();

                // delete all instances of photos for the same album!
                $db->open('../'.$path_db.$db_photos, 1);
                $db->delete('album_id', $_GET['id'], 1);
                $db->close();

                if ($check) {
                    echo 'The album <strong>'.$res[0]['title'].'</strong> has been deleted.<br />';
                }
            }

        } else {
            echo '<p>Are you sure you want to delete this album?</p>';

            echo '<p>Deleting an album also deletes all instances of photos
                    within the album, but these photos are still kept
                    in the <code>uploads</code> database.</p>';

            echo '<p><strong><a href="'.$self.'?op=delete-album&amp;confirm=1&amp;id='.$_GET['id'].'">Yes, delete the album</a>.</strong></p>';
        }

        echo '<p><a href="'.$self.'">Back to <strong>Albums</strong></a>.</p>';

        break;
    }







    case 'reset-cover-photo' : { //!
    // 2004-04-30 20:05:58

        // get the album info
        $db->open('../'.$path_db.$db_albums, 1);
        $res = $db->select('id', $_GET['id']);

        echo '<h2>Reset cover photo for album '.$res[0]['title'].'</h2>';

        $new['cover_image'] = '';
        $db->update('id', $_GET['id'], $new);
        echo 'Cover photo for the album <strong>'.$res[0]['title'].'</strong> has been reset.<br />';

        $db->close();

        // modify last edit time of album
        //set_edit_time($_GET['album_id']);


        break;
    }










    case 'edit-album-sort' : { //!
    // 2004-04-30 20:06:11

        echo '<h2>Albums</h2>';

        // load album photos
        $db->open('../'.$path_db.$db_albums, 1);
        $res = $db->get_all();

        foreach ($res as $value) {
            unset($new);
            if (  isset($_POST['sort_'.$value['id']])  ) {
                $new['sort_order'] = stripslashes($_POST['sort_'.$value['id']]);
            }

            if (  isset($_POST['visible_'.$value['id']])  ) {
                $new['visible'] = '1';
            } else {
                $new['visible'] = '0';
            }

            $db->update('id', $value['id'], $new);

            // modify last edit time of album
            //set_edit_time($value['id']); // cannot stay inside loop!


            echo 'Saved new sort order and visibility info for album <strong>'.$value['title'].'</strong>.<br />';
        }

        $db->close();
        echo '<p><a href="'.$self.'">Back to <strong>Albums</strong></a>.</p>';

        break;
    }









    case 'make-album': { //!
    // 2004-05-01 00:51:40

        $new['title'] = stripslashes($_POST['album']);
        $new['sanitized_name'] = sanitize_title($new['title']);

        $db->open('../'.$path_db.$db_albums, 0);
        $c1 = count($db->select('title', $new['title'], 1)); // problem here!!!
        $c2 = count($db->select('sanitized_name', $new['sanitized_name'], 1));
        $db->close();


        echo '<h2>Add new album</h2>';
        if ( isset($_POST['makecheck']) ) {

            if (  $c1 > 0 || $c2 > 0  ) {
                echo '<p>An album with the same <strong>title</strong> or <strong>sanitized_name</strong> already exists.</p>';
            } else {

                $db->open('../'.$path_db.$db_albums,1);
                $sorter = $db->select('album_id', stripslashes($_POST['album_id']));
                $sorter = $db->order_by($sorter, 'sort_order', 'DESC');

                $new['sort_order'] = $sorter[0]['sort_order'] + 10;
                $new['visible'] = 1;
                $new['description'] = '';
                $new['cover_image'] = '';
                $new['date_created'] = date('Y-m-d H:i:s', time() + (3600*$server_time_offset));
                $new['date_edited'] = date('Y-m-d H:i:s', time() + (3600*$server_time_offset));

                $db->insert($new);
                if ($db->close()) {
                    echo 'The album <strong>'.$new['title'].'</strong> has been created.<br />';
                }
                $db->open('../'.$path_db.$db_albums);
                $results = $db->get_all();
                $results = $db->order_by($results, 'date_created', 'DESC');
            }
            echo '<p><a href="'.$self.'">Return to albums</a>, or <a href="'.$self.'?op=upload-to-album&amp;album_id='.$results[0]['id'].'">upload photos to this photo album</a>.</p>';

        }

        echo '</div>';
        break;
    }












    case 'upload-to-album': { //!
    // 2004-04-29 23:36:21

        /*
            REQUIRES:
                $_GET['album_id']
        */



        // load all albums
        $db->open('../'.$path_db.$db_albums, 0);
        $res = $db->select('id', $_REQUEST['album_id']);
        $db->close();


        if (!isset($_POST['uploadcheck'])) {

            echo '<h2>Upload to: '.$res[0]['title'].'</h2>';
            echo '<form name="form1" enctype="multipart/form-data" method="post" action="'.$self.'?op=upload-to-album"><table>';

            for ($i=0; $i < 8; $i++) {
                echo '<tr><td><label for="uploadfile'.$i.'">Photo #'.($i+1).'</label></td><td><input name="uploadfile'.$i.'" type="file" size="50" id="uploadfile'.$i.'"></td></tr>';
            }

            echo '</table>';
            echo '<input name="album_id" type="hidden" value="'.$_GET['album_id'].'" />';
            echo '<input name="uploadcheck" type="hidden" />
            <br /><br /><input type="submit" name="Submit" value="Upload photos" class="mysubmit" />
            </form>';



        } elseif (isset($_POST['uploadcheck'])) {

            echo '<h2>Upload to: '.$res[0]['title'].'</h2>';

            for ($x=0; $x < 8; $x++) {
            $copy = false;

                //if (isset($_FILES['uploadfile'. $x]['name'])) {
                if (  isset($_FILES['uploadfile'. $x]['tmp_name'])  && check_file_type($_FILES['uploadfile'. $x]['tmp_name'])  ) {


                    $file_name = $_FILES['uploadfile'. $x]['name'];
                    // strip file_name of slashes

                    $file_name = stripslashes($file_name);
                    $file_name = str_replace("'","",$file_name);


                        if ( !file_exists('../'.$path_photos.$file_name) ) {
                            $copy = copy($_FILES['uploadfile'. $x]['tmp_name'], '../'.$path_photos.$file_name);

                            // check if successfully copied
                            if($copy) {
                                echo '<strong>'.$file_name.'</strong> has been uploaded sucessfully.<br />';

                                $info = getimagesize('../'.$path_photos.$file_name);

                                auto_thumbnail($file_name);

                                // add to the uploads db
                                $db->open('../'.$path_db.$db_uploads, 1); //multiple open/close to prevent bug in dbtxt insert()
                                $new['id'] = $db->new_id();
                                $new['filename'] = $file_name;
                                $new['width'] = $info[0];
                                $new['height'] = $info[1];
                                $new['thumbnail'] = $thumbnail_prefix.$file_name;
                                $new['date_uploaded'] = date('Y-m-d H:i:s', time() + (3600*$server_time_offset));

                                $db->insert($new);
                                $db->close();



                                // write to album
                                $db->open('../'.$path_db.$db_photos, 1);

                                $sorter = $db->select('album_id', stripslashes($_POST['album_id']));
                                //$db->sort_by_column($sorter, 'sort_order', 1);
                                $sorter = $db->order_by($sorter, 'sort_order', 1);

                                $new_to_album['id'] = $db->new_id();
                                $new_to_album['upload_id'] = $new['id'];
                                $new_to_album['album_id'] = stripslashes($_POST['album_id']);
                                $new_to_album['sort_order'] = $sorter[0]['sort_order'] + 10;
                                $new_to_album['title'] = $file_name;
                                $new_to_album['caption'] = '';
                                $new_to_album['location'] = '';

                                require_once '../'.$path_lib.'class.exif.php';
                                $exif = new ipap_exif('../'.$path_photos.$file_name);
                                $exif->process_file();
                                if ( strlen($exif->get_exif_date()) > 0 ) {
                                    $new_to_album['date_taken'] = reformat_exif_date($exif->get_exif_date());
                                } else {
                                    $new_to_album['date_taken'] = date('Y-m-d H:i:s', filemtime('../'.$path_photos.$file_name) + (3600*$server_time_offset));
                                }

                                $new_to_album['visible'] = '1';
                                $new_to_album['date_created'] = date('Y-m-d H:i:s', time() + (3600*$server_time_offset));
                                $new_to_album['date_edited'] = date('Y-m-d H:i:s', time() + (3600*$server_time_offset));


                                //print_r($new_to_album);
                                $db->insert($new_to_album);
                                $db->close();
                                echo '<strong>'.$file_name.'</strong> has been added to the <strong>'.$res[0]['title'].'</strong> photo album.<br />';


                                // modify last edit time of album
                                set_edit_time($new_to_album['album_id']);

                                unset($new, $new_to_album);

                            } else {
                                echo '<strong>'.$file_name.'</strong> could not be uploaded!<br />';
                            }

                        } else {
                            echo 'Sorry, the file <strong>'.$_FILES['uploadfile'. $x]['name']. '</strong> already exists.<br />';
                        }




                } elseif( strlen($_FILES['uploadfile'. $x]['name']) > 1 ) {
                    echo '<strong>'.$_FILES['uploadfile'. $x]['name']. '</strong> is not a valid file.<br />';
                }

            }
            echo '<p><a href="'.$self.'">Return to <strong>albums</strong></a>, <a href="'.$self.'?op=upload-to-album&amp;album_id='.$_REQUEST['album_id'].'">upload more to this album</a>, or <a href="'.$self.'?op=edit-album&amp;id='.$_REQUEST['album_id'].'">edit this album&#8217;s details</a>.</p>';

        }

        break;
    }

















    case 'edit-album': { //!
    // 2004-04-30 00:04:23



        if (isset($_REQUEST['save_info'])) {


            $db->open('../'.$path_db.$db_albums, 1);
            $res = $db->select('id', $_REQUEST['album_id']);

            echo '<h2>Editing photo album: '.$res[0]['title'].'</h2>';

            $new['title'] = stripslashes($_POST['album_title']);
            $new['description'] = stripslashes($_POST['album_description']);
            $new['date_created'] = stripslashes($_POST['album_date_created']);
            $new['date_edited'] = date('Y-m-d H:i:s', time() + (3600*$server_time_offset));
            $new['sort_order'] = stripslashes($_POST['album_sort_order']);
            $new['cover_image'] = stripslashes($_POST['album_cover_image']);
            //$new['parent_id'] = stripslashes($_POST['album_parent_id']);

            if (  isset($_POST['album_visible'])  ) {
                $new['visible'] = '1';
            } else {
                $new['visible'] = '0';
            }

            $db->update('id', $_REQUEST['album_id'], $new);
            $db->close();

            // modify last edit time of album
            set_edit_time($_REQUEST['album_id']);

            echo 'The album <strong>'.$new['title'].'</strong> has been edited.<br />';


            echo '<p><a href="'.$self.'?op=edit-album&amp;id='.$_REQUEST['album_id'].'">Continue editing this album</a>, <a href="'.$self.'?op=upload-to-album&amp;album_id='.$_REQUEST['album_id'].'">upload to this album</a>, or <a href="'.$self.'">return to albums</a>.</p>';




        } else {

            // get the album info
            $db->open('../'.$path_db.$db_albums, 0);
            $res = $db->select('id', $_GET['id']);
            $db->close();


            echo '<h2>Editing photo album: '.$res[0]['title'].'</h2>';
            // load album photos
            $db->open('../'.$path_db.$db_photos, 0);
            $res2 = $db->select('album_id', $_GET['id']);
            $db->close();


            $db->open('../'.$path_db.$db_uploads, 0);

            for ($i=0; $i < count($res2); $i++) {
                unset($tmp);
                $tmp = $db->select('id', $res2[$i]['upload_id']);
                $res2[$i]['filename'] = $tmp[0]['filename'];
                $res2[$i]['width'] = $tmp[0]['width'];
                $res2[$i]['height'] = $tmp[0]['height'];
            }
            $db->close();


            echo '<p>Special characters in the <strong>title</strong> and <strong>description</strong>
            field are automatically converted to their markup equivalents. In addition, linebreaks
            in the description are automatically converted. A <strong>single linebreak for a new line</strong>, <strong>two
            linebreaks to start a new paragraph</strong>.
            </p>';

            echo '<form enctype="multipart/form-data" method="post" action="'.$self.'?op=edit-album">';
            echo '<input type="hidden" name="album_id" value="'.$res[0]['id'].'" />';
            echo '<input type="hidden" name="save_info" />';

            echo '<p class="formtype"><label for="album_title">Album Title:</label><br /><input type="text" id="album_title" name="album_title" size="50" value="'.$res[0]['title'].'" /></p>';


            echo '<p class="formtype"><label for="album_description">Album Description:</label><br /><textarea id="album_description" name="album_description" rows="5" cols="50">'.$res[0]['description'].'</textarea></p>';

            echo '<p class="formtype"><label for="album_date_created">Date Created/Cloned:</label><br /><input type="text" id="album_date_created" name="album_date_created" size="35" value="'.$res[0]['date_created'].'" /></p>';

            echo '<p class="formtype"><label for="album_sort_order">Sort Order:</label><br /><input type="text" id="album_sort_order" name="album_sort_order" size="10" value="'.$res[0]['sort_order'].'" /></p>';

            echo '<p class="formtype"><label for="album_cover_image">Cover Image ID:</label><br /><input type="text" id="album_cover_image" name="album_cover_image" size="10" value="'.$res[0]['cover_image'].'" /></p>';

            //echo '<p class="formtype"><label for="album_parent_id">Parent album ID:</label><br /><input type="text" id="album_parent_id" name="album_parent_id" size="10" value="'.$res[0]['parent_id'].'" /></p>';

            if ($res[0]['visible'] == 1) {
                $checked = 'checked="checked"';
            } else {
                $checked = '';
            }

            echo '<p class="formtype"><label for="album_visible">Visible?</label><br /><input type="checkbox" id="album_visible" name="album_visible" '.$checked.' /></p>';
            echo '<input class="mysubmit" type="submit" name="Submit" value="Save changes" />';
            echo '</form>';




            echo '<h2>Photos in this album</h2>';

            echo '<p><strong>sort_order</strong> - Used for display sequence of photo albums.
                    Numerically sorted (lowest first) for photos.<br />
                        <strong>visible</strong> - Uncheck this to hide a photo.<br />
                        <strong>title</strong> - Edit this to change a photo&#8217;s title. Be sure to save your
                        changes by using the submit button at the end of the photo listing.<br />
                        <strong>edit</strong> - Edit the photo&#8217;s details.<br />
                        <strong>cover</strong> - Set this photo as the album&#8217;s cover (first photo displayed).
                        <strong>thumbnail</strong> - Re-select a thumbnail for this photo.
                        <strong>clone</strong> - Clone the photo to another photo album.
                        <strong>remove</strong> - Remove photo from this album. (But not from the database.)
                    </p>';


            echo '<form enctype="multipart/form-data" method="post" action="'.$self.'?op=edit-photo-sort">';
            echo '<table>
            <tr>
                <th>Thumbnail</th>
                <th>Sort Order</th>
                <th>Visible?</th>
                <th>Info</th>
                <th>options</th>
            </tr>
            ';

            foreach ($res2 as $value) {

                if (!file_exists('../'.$path_photos.'thumb__'.$value['filename'])) {
                    $img = '<img src="no-thumbnail.gif" />';
                    $full = '';
                } else {
                    $img = '<img src="../'.$path_photos.'thumb__'.$value['filename'].'" />';
                    $full = '<br /><a href="../'.$path_photos.$value['filename'].'">view full photo</a>';
                }

                if ($value['visible'] == 1) {
                    $checked = 'checked="checked"';
                } else {
                    $checked = '';
                }

                echo '<tr>
                    <td>'.$img.$full.'</td>
                    <td><input type="text" id="sort_'.$value['id'].'" name="sort_'.$value['id'].'" size="4" value="'.$value['sort_order'].'" /></td>
                    <td><input type="checkbox" id="visible_'.$value['id'].'" name="visible_'.$value['id'].'" '.$checked.' /></td>
                    <td><label for="title_'.$value['id'].'">Title:</label><br /> <input type="text" id="title_'.$value['id'].'" name="title_'.$value['id'].'" size="24" value="'.htmlspecialchars($value['title']).'" /><br /><br />
                        <span class="info">'.$value['width'].' x '.$value['height'].' | '.round(filesize('../'.$path_photos.$value['filename'])/1024).' KB | Last changed : '.date($gallery_date_format, strtotime($value['date_edited'])).'</span>

                    </td>
                    <td>
                        <a href="'.$self.'?op=edit-photo&amp;id='.$value['id'].'&amp;album_id='.$_GET['id'].'" title="Edit this photo&#8217;s details.">edit</a> .
                        <a href="'.$self.'?op=set-cover-photo&amp;id='.$value['id'].'&amp;album_id='.$_GET['id'].'" title="Set photo as this album&#8217;s cover.">cover</a> .
                        <a href="'.$self.'?op=reset-thumbnail&amp;id='.$value['upload_id'].'&amp;album_id='.$_GET['id'].'" title="Change this photo&#8217;s thumbnail.">thumbnail</a> .
                        <a href="'.$self.'?op=clone-photo&amp;id='.$value['id'].'&amp;album_id='.$_GET['id'].'" title="Clone this photo to another album.">clone</a> .
                        <a href="'.$self.'?op=delete-photo&amp;id='.$value['id'].'&amp;album_id='.$_GET['id'].'" title="Remove photo from this album.">remove</a>
                        </td>
                </tr>';

            }
            echo '</table>';
            echo '<input type="hidden" name="album_id" value="'.$_GET['id'].'" />';
            echo '<p><input class="mysubmit" type="submit" name="Submit" value="Save changes to sort,visibility, &amp; title" /></p>';

            echo '</form>';

        }

        break;
    }












    case 'edit-photo-sort': { //!
    // 2004-04-30 00:20:05



        // get the album info
        $db->open('../'.$path_db.$db_albums, 0);
        $album = $db->select('id', $_REQUEST['album_id']);
        $db->close();



        echo '<h2>Edit: '.$album[0]['title'].'</h2>';

        // load album photos
        $db->open('../'.$path_db.$db_photos, 1);
        $res = $db->select('album_id', stripslashes($_POST['album_id']));

        foreach ($res as $value) {
            unset($new);
            if (  isset($_POST['sort_'.$value['id']])  ) {
                $new['sort_order'] = stripslashes($_POST['sort_'.$value['id']]);
            }

            if (  isset($_POST['title_'.$value['id']])  ) {
                $new['title'] = stripslashes($_POST['title_'.$value['id']]);
            }

            if (  isset($_POST['visible_'.$value['id']])  ) {
                $new['visible'] = '1';
            } else {
                $new['visible'] = '0';
            }

            $db->update('id', $value['id'], $new);
            echo 'Saved new title, sort order and visibility info for photo <strong>'.$value['title'].'</strong>.<br />';
        }

        $db->close();

        // modify last edit time of album
        //set_edit_time($_POST['album_id']);

        echo '<p><a href="'.$self.'?op=edit-album&amp;id='.$_REQUEST['album_id'].'">Continue editing this album</a>, <a href="'.$self.'?op=upload-to-album&amp;album_id='.$_REQUEST['album_id'].'">upload to this album</a>, or <a href="'.$self.'">return to albums</a>.</p>';

        break;
    }







    case 'edit-photo': { //!
    // 2004-04-30 00:28:41


        if (!isset($_POST['save'])) {

            // get info for editing
            $db->open('../'.$path_db.$db_photos, 0);
            $res = $db->select('id', $_GET['id']);
            $db->close();

            // just get the filename
            $db->open('../'.$path_db.$db_uploads, 0);
            $res2 = $db->select('id', $res[0]['upload_id']);
            $db->close();

            $photo = $db->join($res, $res2, 'upload_id', 'id');
            $photo = $photo[0];

            echo '<h2>Editing: '.$photo['title'].'</h2>';

            echo '<p>Special characters in the <strong>title</strong> and <strong>caption</strong>
            field are automatically converted to their markup equivalents. In addition, linebreaks
            in the caption are automatically converted. A <strong>single linebreak for a new line</strong>, <strong>two
            linebreaks to start a new paragraph</strong>.
            </p>';


            if (!file_exists('../'.$path_photos.'thumb__'.$photo['__filename'])) {
                $img = '<img src="no-thumbnail.gif" />';
                $full = '';
            } else {
                $img = '<img src="../'.$path_photos.'thumb__'.$photo['__filename'].'" />';
                    $full = '<br /><a href="../'.$path_photos.$photo['__filename'].'">view full photo</a>';
            }

            echo '<form enctype="multipart/form-data" method="post" action="'.$self.'?op=edit-photo">';
            echo '<input type="hidden" name="photo_id" value="'.$photo['id'].'" />';
            echo '<input type="hidden" name="album_id" value="'.$_GET['album_id'].'" />';
            echo '<input type="hidden" name="save" />';
            echo '<p style="float:left; margin:0 20px 350px 0">'.$img.$full.'</p>';

            echo '<p><label for="photo_title">Photo Title:</label><br /><input type="text" id="photo_title" name="photo_title" size="50" value="'.$photo['title'].'" /></p>';


            echo '<p><label for="photo_caption">Photo Caption:</label><br /><textarea id="photo_caption" name="photo_caption" rows="5" cols="50">'.$photo['caption'].'</textarea></p>';


            echo '<p><label for="photo_location">Location:</label><br /><input type="text" id="photo_location" name="photo_location" size="35" value="'.$photo['location'].'" /></p>';


            if (isset($_POST['reextract'])) {
                require_once '../'.$path_lib.'class.exif.php';
                $exif = new ipap_exif('../'.$path_photos.$photo['__filename']);
                $exif->process_file();
                $photo['date_taken'] = reformat_exif_date($exif->get_exif_date());
            }


            echo '<p><label for="photo_date_taken">Date Taken:</label><br /><input type="text" id="photo_date_taken" name="photo_date_taken" size="35" value="'.$photo['date_taken'].'" /></p>';

            echo '<p><label for="photo_date_created">Date Created/Cloned:</label><br /><input type="text" id="photo_date_created" name="photo_date_created" size="35" value="'.$photo['date_created'].'" /></p>';

            echo '<p><label for="photo_sort_order">Sort Order:</label><br /><input type="text" id="photo_sort_order" name="photo_sort_order" size="10" value="'.$photo['sort_order'].'" /></p>';

            //echo '<p><label for="photo_visible">Visible? (0 or 1):</label><br /><input type="text" id="photo_visible" name="photo_visible" size="10" value="'.$photo['visible'].'" /></p>';

            if ($photo['visible'] == 1) {
                $checked = 'checked="checked"';
            } else {
                $checked = '';
            }
            echo '<p><label for="photo_visible">Visible?</label><input type="checkbox" id="photo_visible" name="photo_visible" '.$checked.' /></p>';

            echo '<p><input class="mysubmit" type="submit" name="Submit" value="Save changes" /></p>';

            echo '</form>';


            if (strlen($photo['date_taken']) < 2) { // re-extract exif date, maybe other things later
                echo '<form enctype="multipart/form-data" method="post">';
                echo '<input type="hidden" name="reextract" />';
                echo '<input class="mysubmit" type="submit" name="Submit" value="Re-extract exif date" />';
                echo '</form>';
            }


        } elseif (isset($_POST['save'])) {

            echo '<h2>Editing: '.stripslashes($_POST['photo_title']).'</h2>';

            $db->open('../'.$path_db.$db_photos, 1);
            //$new['id'] = $db->new_id();

            $new['title'] = stripslashes($_POST['photo_title']);
            $new['caption'] = stripslashes($_POST['photo_caption']);
            $new['location'] = stripslashes($_POST['photo_location']);
            $new['date_taken'] = stripslashes($_POST['photo_date_taken']);
            $new['date_created'] = stripslashes($_POST['photo_date_created']);
            $new['date_edited'] = date('Y-m-d H:i:s', time() + (3600*$server_time_offset));
            $new['sort_order'] = stripslashes($_POST['photo_sort_order']);

            if (  isset($_POST['photo_visible'])  ) {
                $new['visible'] = '1';
            } else {
                $new['visible'] = '0';
            }


            $db->update('id', $_POST['photo_id'], $new);
            $db->close();

            // modify last edit time of album
            set_edit_time($_POST['album_id']);

            echo 'The photo <strong>'.$new['title'].'</strong> has been edited.<br />';
            echo '<a href="'.$_SERVER['HTTP_REFERER'].'">Edit the photo again</a> or <a href="'.$self.'?op=edit-album&amp;id='.stripslashes($_POST['album_id']).'">go back to its album</a>.<br />';

        }


        break;
    }






    case 'set-cover-photo': { //!
    // 2004-04-30 00:45:37


        // get the album info
        $db->open('../'.$path_db.$db_albums, 1);
        $res = $db->select('id', $_GET['album_id']);

        echo '<h2>Set cover photo: '.$res[0]['title'].'</h2>';

        $new['cover_image'] = $_GET['id'];

        if ($db->update('id', $_GET['album_id'], $new)) {
            echo 'Cover photo for the album <strong>'.$res[0]['title'].'</strong> has been set.<br />';
        }
        $db->close();

        echo '<p><a href="'.$self.'?op=edit-photo&amp;id='.$_REQUEST['id'].'&amp;album_id='.$_REQUEST['album_id'].'">Edit the photo</a> or <a href="'.$self.'?op=edit-album&amp;id='.$_REQUEST['album_id'].'">return to its album</a>.</p>';


        // modify last edit time of album
        //set_edit_time($_GET['album_id']);

        break;
    }










    case 'delete-photo': { //!
    // 2004-04-30 00:45:37

        $db->open('../'.$path_db.$db_photos);
        $res = $db->select('id', $_REQUEST['id']);
        $db->close();

        $db->open('../'.$path_db.$db_albums);
        $res2 = $db->select('id', $_REQUEST['album_id']);
        $db->close();


        echo '<h2>Remove photo from album</h2>';

        if (isset($_REQUEST['confirm'])) {



            // delete
            $db->open('../'.$path_db.$db_photos, 1);
            $res = $db->select('id', $_REQUEST['id']);
            $check = $db->delete('id', $_REQUEST['id']);
            $db->close();




            $db->open('../'.$path_db.$db_albums, 1);
            $res2 = $db->select('id', $_REQUEST['album_id']);
            if ($res2[0]['cover_image'] == $_REQUEST['id']) {
                $update['cover_image'] = '';
                $db->update('id', $_REQUEST['album_id'], $update);
                echo 'Cover image removed from this album.<br />';
            }
            $db->close();


            if ($check) {
                echo '<p>The photo <strong>'.$res[0]['title'].'</strong> has been removed from the album.</p>';
            }

        } else {
            echo '<p>Are you sure you want to remove the photo <strong>'.$res[0]['title'].'</strong> from the album <strong>'.$res2[0]['title'].'</strong>?</p>';

            echo '<p>Note that deleting a photo from the album does not
                    delete it from the <code>uploads</code> database.</p>';

            echo '<p><strong><a href="'.$self.'?op=delete-photo&amp;confirm=1&amp;id='.$_REQUEST['id'].'">Yes, remove the photo</a>.</strong></p>';

            echo '<p><strong><a href="'.$self.'?op=edit-album&amp;id='.$_REQUEST['album_id'].'">No, return to the album</a>.</strong></p>';
        }

        break;
    }









    case 'clone-photo': { //!
    // 2004-04-30 00:45:37

        if (isset($_REQUEST['confirm'])) {

            // open photos db
            $db->open('../'.$path_db.$db_photos, 0);
            $res = $db->select('id', $_GET['photo_id']); //the photo to be copied
            $res3 = $db->select('album_id', $_GET['album_id']);// all photos in the album
            $sorter = $db->select('album_id', $_GET['album_id']);
            //$db->sort_by_column($sorter, 'sort_order', 1);
            $sorter = $db->order_by($sorter, 'sort_order', 1);
            $db->close();


            // get name of target album
            $db->open('../'.$path_db.$db_albums, 0);
            $res2 = $db->select('id', $_GET['album_id']);
            $db->close();


            $verify = true;
            foreach ($res3 as $value) {
                if ($value['upload_id'] == $res[0]['upload_id']) {
                    $verify = false;
                }
            }


            echo '<h2>'.$res[0]['title'].'</h2>';

            //echo '<p><img src="../ipap-photos/'.$res[0]['filename'].'" /></p>';


            if (!$verify) {
                echo 'The photo <strong>'.$res[0]['filename'].'</strong> is already in this album.';
            } else {
                if ( isset($_GET['album_id']) && isset($_GET['photo_id']) ) {

                    // write to album
                    $db->open('../'.$path_db.$db_photos, 1);

                    $new['id'] = $db->new_id();
                    $new['upload_id'] = $res[0]['upload_id'];
                    $new['album_id'] = $_GET['album_id'];
                    $new['sort_order'] = $sorter[0]['sort_order'] + 10;
                    $new['title'] = $res[0]['title'];
                    $new['caption'] = $res[0]['caption'];
                    $new['location'] = $res[0]['location'];

        /*
                    require_once '../ipap-lib/class.exif.php';
                    $exif = new ipap_exif('../ipap-photos/'.$res[0]['filename']);
                    $exif->process_file();
                    if ( strlen($exif->get_exif_date()) > 0 ) {
                        //$new['date_taken'] = date('Y-m-d H:i:s', strtotime($exif->get_exif_date()));
                        $new['date_taken'] = reformat_exif_date($exif->get_exif_date());
                    } else {
                        $new['date_taken'] = date('Y-m-d H:i:s', filemtime('../ipap-photos/'.$res[0]['filename']) + (3600*$server_time_offset));
                        //$new['date_taken'] = '';
                    }

         */
                    $new['visible'] = $res[0]['visible'];
                    $new['date_taken'] = $res[0]['date_taken'];
                    $new['date_created'] = date('Y-m-d H:i:s', time() + (3600*$server_time_offset));
                    $new['date_edited'] = date('Y-m-d H:i:s', time() + (3600*$server_time_offset));


                    $db->insert($new);
                    $db->close();


                    // modify last edit time of album
                    set_edit_time($_GET['album_id']);


                    echo 'The photo <strong>'.$res[0]['title'].'</strong> has been copied to the <strong>'.$res2[0]['title'].'</strong> album.';

                }
            }



        } else {


            // use the _GET to display the photo being categorized
            $db->open('../'.$path_db.$db_photos, 0);
            $res = $db->select('id', $_GET['id']);
            $db->close();

            $db->open('../'.$path_db.$db_uploads, 0);
            $res2 = $db->select('id', $res[0]['upload_id']);
            $db->close();

            echo '<h2>Clone '.$res2[0]['filename'].' to another photo album</h2>';
            echo '<p><img src="../'.$path_photos.$res2[0]['filename'].'" /></p>';


            // load all albums
            $db->open('../'.$path_db.$db_albums, 0);
            $res2 = $db->get_all();
            $db->close();


            echo '<p>';
            foreach ($res2 as $value) {
                echo '<a href="'.$self.'?op=clone-photo&amp;confirm=1&amp;album_id='.$value['id'].'&amp;photo_id='.$res[0]['id'].'">clone this photo to the  <strong>'.$value['title'].'</strong> album</a><br />';
            }
            echo '</p>';


        }

        break;
    }













    case 'reset-thumbnail': { //!
    // 2004-04-30 00:45:37

        if (isset($_REQUEST['confirm'])) {


            $db->open('../'.$path_db.$db_uploads, 0);
            $res = $db->select('id', $_GET['id']);
            $db->close();




            echo '<h2>Reset Thumbnail</h2>';




            //set_thumbnail($res[0]['filename'], $_GET['t']);



            // function fork! =============


            //global $thumbnail_quality, $thumbnail_size, $path_photos, $path_temp;

            $img = $res[0]['filename'];
            $t = $_GET['t'];


            $image_path = '../'.$path_photos.$img;
            $copy_file = '../'.$path_photos.'thumb__'.$img;

            $size = getimagesize($image_path);


            if ($size[0] > $size[1]) {
                $orientation = 'landscape';
                if ($t == 'w') {
                    if (copy('../'.$path_temp.'w_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                } elseif ($t == 'c') {
                    if (copy('../'.$path_temp.'c_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                } elseif ($t == 'e') {
                    if (copy('../'.$path_temp.'e_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                }
                unlink('../'.$path_temp.'w_thumb__'.$img);
                unlink('../'.$path_temp.'c_thumb__'.$img);
                unlink('../'.$path_temp.'e_thumb__'.$img);
            } elseif ($size[0] < $size[1]) {
                $orientation = 'portrait';
                if ($t == 'n') {
                    if (copy('../'.$path_temp.'n_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                } elseif ($t == 'c') {
                    if (copy('../'.$path_temp.'c_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                } elseif ($t == 's') {
                    if (copy('../'.$path_temp.'s_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                }
                unlink('../'.$path_temp.'n_thumb__'.$img);
                unlink('../'.$path_temp.'c_thumb__'.$img);
                unlink('../'.$path_temp.'s_thumb__'.$img);
            } elseif ($size[0] == $size[1]) {
                $orientation = 'square';
                if ($t == 'c') {
                    if (copy('../'.$path_temp.'c_thumb__'.$img, $copy_file)) {
                       echo 'thumbnail for <strong>'.$img.'</strong> has been set.<br />';
                    } else {
                       echo 'thumbnail for <strong>'.$img.'</strong> has not been set. ERROR!<br />';
                    }
                }
                unlink('../'.$path_temp.'c_thumb__'.$img);
            }




            $db->open('../'.$path_db.$db_uploads, 1);
            $new['thumbnail'] = 'thumb__'.$res[0]['filename'];
            $db->update('id', $_GET['id'], $new);
            $db->close();


            if ('' != $_REQUEST['album_id']) {
                echo '<p><a href="'.$self.'?op=edit-album&amp;id='.$_REQUEST['album_id'].'">Return to the photo&#8217;s album.</a></p>';
            }






        } else {



            $db->open('../'.$path_db.$db_uploads, 0);
            $res = $db->select('id', $_GET['id']);
            $db->close();


            echo '<h2>Reset Thumbnail</h2>';




            //make_thumbnails($res[0]['filename'], $res[0]['id']);

            // function fork! =============

            //global $thumbnail_quality, $thumbnail_size, $path_photos, $path_temp;


            $img = $res[0]['filename'];
            $id = $res[0]['id'];


            $image_path = '../'.$path_photos.$img;

            $size = getimagesize($image_path);


            if ($size[0] > $size[1]) {
                $orientation = 'landscape';
                // w
                $w_src_x = 0;
                $w_src_y = 0;

                // c
                $c_src_y = 0;
                $c_src_x = intval(($size[0] - $size[1])/2);

                // e
                $e_src_y = 0;
                $e_src_x = $size[0] - $size[1];

                $src_img = imagecreatefromjpeg($image_path); // make 'connection' to image

                // west thumbnail
                $w_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($w_thumb, $src_img, 0, 0, $w_src_x ,$w_src_y, $thumbnail_size, $thumbnail_size, $size[1], $size[1]);
                imagejpeg($w_thumb, '../'.$path_temp.'w_thumb__'.$img, $thumbnail_quality);
                imagedestroy($w_thumb);

                // center thumbnail
                $c_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($c_thumb, $src_img, 0, 0, $c_src_x ,$c_src_y, $thumbnail_size, $thumbnail_size, $size[1], $size[1]);
                imagejpeg($c_thumb, '../'.$path_temp.'c_thumb__'.$img, $thumbnail_quality);
                imagedestroy($c_thumb);

                // east thumbnail
                $e_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($e_thumb, $src_img, 0, 0, $e_src_x ,$e_src_y, $thumbnail_size, $thumbnail_size, $size[1], $size[1]);
                imagejpeg($e_thumb, '../'.$path_temp.'e_thumb__'.$img, $thumbnail_quality);
                imagedestroy($e_thumb);

                imagedestroy($src_img);


            } elseif ($size[0] < $size[1]) {
                $orientation = 'portrait';
                // n
                $n_src_x = 0;
                $n_src_y = 0;

                // c
                $c_src_y = intval(($size[1] - $size[0])/2);
                $c_src_x = 0;

                // s
                $s_src_y = $size[1] - $size[0];
                $s_src_x = 0;

                $src_img = imagecreatefromjpeg($image_path); // make 'connection' to image

                // north thumbnail
                $n_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($n_thumb, $src_img, 0, 0, $n_src_x ,$n_src_y, $thumbnail_size, $thumbnail_size, $size[0], $size[0]);
                imagejpeg($n_thumb, '../'.$path_temp.'n_thumb__'.$img, $thumbnail_quality);
                imagedestroy($n_thumb);

                // center thumbnail
                $c_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($c_thumb, $src_img, 0, 0, $c_src_x ,$c_src_y, $thumbnail_size, $thumbnail_size, $size[0], $size[0]);
                imagejpeg($c_thumb, '../'.$path_temp.'c_thumb__'.$img, $thumbnail_quality);
                imagedestroy($c_thumb);

                // south thumbnail
                $s_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($s_thumb, $src_img, 0, 0, $s_src_x ,$s_src_y, $thumbnail_size, $thumbnail_size, $size[0], $size[0]);
                imagejpeg($s_thumb, '../'.$path_temp.'s_thumb__'.$img, $thumbnail_quality);
                imagedestroy($s_thumb);

                imagedestroy($src_img);






            } elseif ($size[0] == $size[1]) {
                $orientation = 'square';
                // c
                $c_src_y = 0;
                $c_src_x = 0;

                $src_img = imagecreatefromjpeg($image_path); // make 'connection' to image

                // center thumbnail
                $c_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
                imagecopyresampled($c_thumb, $src_img, 0, 0, $c_src_x ,$c_src_y, $thumbnail_size, $thumbnail_size, $size[0], $size[0]);
                imagejpeg($c_thumb, '../'.$path_temp.'c_thumb__'.$img, $thumbnail_quality);
                imagedestroy($c_thumb);

                imagedestroy($src_img);

            }





            echo '<table><tr>';


            echo '<th colspan="3"><h3>'.$img.' ('.$orientation.')</h3>Choose a thumbnail:</th>';

                if ($orientation == 'landscape') {
                    echo '<tr>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;id='.$id.'&amp;album_id='.$_REQUEST['album_id'].'&amp;t=w"><img src="../'.$path_temp.'w_thumb__'.$img.'" /><br /> left-aligned</a></td>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;id='.$id.'&amp;album_id='.$_REQUEST['album_id'].'&amp;t=c"><img src="../'.$path_temp.'c_thumb__'.$img.'" /><br /> centered</a></td>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;id='.$id.'&amp;album_id='.$_REQUEST['album_id'].'&amp;t=e"><img src="../'.$path_temp.'e_thumb__'.$img.'" /><br /> right-aligned</a></td>';
                    echo '</tr>';
                }

                if ($orientation == 'portrait') {
                    echo '<tr>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;id='.$id.'&amp;album_id='.$_REQUEST['album_id'].'&amp;t=n"><img src="../'.$path_temp.'n_thumb__'.$img.'" /><br /> top-aligned</a></td>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;id='.$id.'&amp;album_id='.$_REQUEST['album_id'].'&amp;t=c"><img src="../'.$path_temp.'c_thumb__'.$img.'" /><br /> centered</a></td>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;id='.$id.'&amp;album_id='.$_REQUEST['album_id'].'&amp;t=s"><img src="../'.$path_temp.'s_thumb__'.$img.'" /><br /> bottom-aligned</a></td>';
                    echo '</tr>';
                }

                if ($orientation == 'square') {
                    echo '<tr>';
                    echo '<td><a href="'.$self.'?op=reset-thumbnail&amp;confirm=1&amp;id='.$id.'&amp;album_id='.$_REQUEST['album_id'].'&amp;t=c"><img src="../'.$path_temp.'c_thumb__'.$img.'" /><br /> centered</a></td>';
                    echo '</tr>';
                }



            echo '</tr></table>';



        }




        break;
    }









    case 'tools': { //!
    // 2004-04-30 00:45:37
    ?>
<h2>Tools</h2>

<p>The following tools are provided for optimizing your installation
and database files. Typically, you don&#8217;t need to do these things
unless you have a fairly large photo collection.
</p>


<!-- <p><strong><a href="<?php echo $self; ?>?op=tools-backup">Backup</a></strong><br />
Create a backup of the database and other critical files in case
something breaks. You&#8217;ll never know.
</p>

<p><strong><a href="<?php echo $self; ?>?op=tools-list-uploads">List Uploads</a></strong><br />
Use this to see all uploads in your database, and check if all
listed files exists with their corresponding thumbnails.
</p>
 -->

<dl>
    <dt><a href="<?php echo $self; ?>?op=tools-backup">Backup</a></dt>
    <dd>Create a backup of the database and other critical files in case
    something breaks. You&#8217;ll never know.</dd>

    <dt><a href="<?php echo $self; ?>?op=tools-list-uploads">List Uploads</a></dt>
    <dd>Use this to see all uploads in your database, and check if all
    listed files exists with their corresponding thumbnails.</dd>

<!--     <dt><a href="">Code Cleanup</a></dt>
    <dd>Use this to see all uploads in your database, and check if all
    listed files exists with their corresponding thumbnails.</dd> -->
</dl>


    <?php
        break;
    }









    case 'tools-backup' : { //!

        echo '<h2>Backups</h2>';
        echo $tool_menu;

        if (isset($_REQUEST['confirm'])) {


            include_once '../'.$path_lib.'archive.php';

            $zip = new zipfile('', array('overwrite' => 1));

            $files[] = '../'.$path_db.$db_photos;
            $files[] = '../'.$path_db.$db_albums;
            $files[] = '../'.$path_db.$db_uploads;

            $files[] = '../'.$gallery_tpl;
            $files[] = '../'.$album_tpl;
            $files[] = '../'.$css_tpl;

            $files[] = '../ipap-config.php';
            $files[] = '../ipap-settings.php';

            $zip->addfiles($files);
            $zip->filewrite('../backup.zip');
            echo '<p>A new backup has just been created. <strong><a href="../backup.zip">Download backup</a>.</strong></p>';



        } else {

            echo '<p><a href="../backup.zip">Download backup</a>.</p>';
            echo '<p>When creating a new backup, make sure the current
            database is in good working order. <strong><a href="'.$self.'?op=tools-backup&amp;confirm=1">Create a new backup</a>.</strong></p>';

        }

        break;
    }






    case 'tools-list-uploads' : { //!


        $db->open('../'.$path_db.$db_uploads, 0);
        $res = $db->get_all();
        $res = $db->order_by($res, 'id', 1);
        $db->close();


        $db->open('../'.$path_db.$db_photos, 0);
        $res_photos = $db->get_all();
        $db->close();

        $db->open('../'.$path_db.$db_albums, 0);
        $res_albums = $db->get_all();
        $db->close();


        $res_m1 = $db->join($res_photos, $res_albums, 'album_id', 'id', 'm1__');
        //$res_m2 = $db->join($res_m1, $res, 'upload_id', 'id', 'm2__');



        if (!$_GET['mode'] == 'all' && count($res) > 10) {
            $res = array_slice($res, 0, 10);
        } elseif (!$_GET['mode'] == 'next20' && count($res) > 30) {
            $res = array_slice($res, 10, 20);
        }


        echo '<h2>List Uploads</h2>';
        echo $tool_menu;

            echo '<p><strong>copy</strong> - Copy to an album.<br />
                        <strong>thumbnail</strong> - Re-select a thumbnail for this photo.<br />
                        <strong>delete</strong> - Delete photo from the database (and all albums it is contained in!).
                    </p>';


        echo '<p><a href="'.$self.'?op=tools-list-uploads">10 most recent uploads</a> |
            <a href="'.$self.'?op=tools-list-uploads&amp;mode=next20">next 20 uploads</a> |
            <a href="'.$self.'?op=tools-list-uploads&amp;mode=all">all uploads</a>
        </p>';


        echo '<table>
        <tr>
            <th>ID</th>
            <th>Filename</th>
            <th>Width</th>
            <th>Height</th>
            <th>Thumbnail</th>
            <th>Info</th>
            <th>Options</th>
        </tr>
        ';

        foreach ($res as $value) {

            if (!file_exists('../'.$path_photos.'thumb__'.$value['filename'])) {
                $img = '<img src="no-thumbnail.gif" />';
            } else {
                $img = '<img src="../'.$path_photos.'thumb__'.$value['filename'].'" />';
            }

            $dne = '';
            if (!file_exists('../'.$path_photos.$value['filename'])) {
                $dne = '<br /> Photo does not exist!';
            }

            $found_in = '<br />Included in:';
            $in_gal = 0;
            foreach ($res_m1 as $ph) {
            	if ($value['id'] == $ph['upload_id']) {
                    $in_gal = 1;
            		$found_in .= '<br /><strong><a href="'.$self.'?op=edit-album&amp;id='.$ph['album_id'].'">'.$ph['m1__title'].'</a></strong>';
            	}
            }
            if (!$in_gal) {
                $found_in = '<br /><strong>Not in any album!</strong>';
            }


            echo '<tr>
                <td>'.$value['id'].'</td>
                <td>'.smarty_modifier_truncate($value['filename'], 16, '...',1).$dne.'</td>
                <td> '.$value['width'].'</td>
                <td> '.$value['height'].'</td>
                <td> '.$img.'</td>
                <td>Uploaded: '.date($gallery_date_format, strtotime($value['date_uploaded'])).$found_in.'</td>
                <td>
                <p><a href="'.$self.'?op=tools-copy-to-album&amp;id='.$value['id'].'">copy</a> .
                    <a href="'.$self.'?op=reset-thumbnail&amp;id='.$value['id'].'">thumbnail</a> .
                    <a href="'.$self.'?op=tools-delete-upload&amp;id='.$value['id'].'">delete</a>
                    </p>    
                </td>
            </tr>';

        }

        echo '</table>';

        /* echo '<pre>';
        print_r($res_m1);
        echo '</pre>'; */

        break;
    }








    case 'tools-delete-upload' : { //!


        // delete
        $db->open('../'.$path_db.$db_uploads, 0);
        $res = $db->select('id', $_GET['id']);
        $db->close();


        echo '<h2>Delete Upload</h2>';
        echo $tool_menu;


        if (!isset($_GET['confirm'])) {
            
            echo '<p>Deleting this uploaded photo will also delete it in all photo albums
                    it is currently in. Are you sure?</p>';

            echo '<p><strong><a href="'.$self.'?op=tools-delete-upload&amp;confirm=1&amp;id='.$_GET['id'].'">Yes, delete the photo</a>.</strong></p>';


        } elseif (isset($_GET['confirm'])) {

            // delete from albums
            $db->open('../'.$path_db.$db_photos, 1);
            $db->delete('album_id', $_GET['id'], 1);
            $db->close();


            // delete from uploads
            $db->open('../'.$path_db.$db_uploads, 1);
            $db->delete('id', $_GET['id'], 1);
            $db->close();


            @unlink('../'.$path_photos.$res[0]['filename']);
            @unlink('../'.$path_photos.'thumb__'.$res[0]['filename']);

            // modify last edit time of album should be here!
            //set_edit_time($_GET['album_id']); // cannot stay inside loop!

            echo '<p>The photo <strong>'.$res[0]['filename'].'</strong> has been deleted.</p>';

        }

        break;
    }












    case 'tools-copy-to-album' : { //!
        if (!isset($_REQUEST['confirm'])) {
        	

            // use the _GET to display the photo being categorized
            $db->open('../'.$path_db.$db_uploads, 0);
            $res = $db->select('id', $_GET['id']);
            $db->close();

            echo '<h2>Copy to album</h2>';
            echo $tool_menu;
            echo '<p><img src="../'.$path_photos.$res[0]['filename'].'" /></p>';


            // load all albums
            $db->open('../'.$path_db.$db_albums, 0);
            $res2 = $db->get_all();
            $db->close();


            echo '<p>Photo: <strong>'.$res[0]['filename'].'</strong></p>';

            echo '<p>';
            foreach ($res2 as $value) {
                echo '<a href="'.$self.'?op=tools-copy-to-album&amp;confirm=1&amp;target='.$value['id'].'&amp;src='.$res[0]['id'].'">copy this photo to the  <strong>'.$value['title'].'</strong> album</a><br />';
            }
            echo '</p>';



        } elseif (isset($_REQUEST['confirm'])) {
        	
        	

            // get upload id
            $db->open('../'.$path_db.$db_uploads, 0);
            $res = $db->select('id', $_GET['src']);
            $db->close();


            // get id of target album
            $db->open('../'.$path_db.$db_albums, 0);
            $res2 = $db->select('id', $_GET['target']);
            $db->close();


            // for verify
            $db->open('../'.$path_db.$db_photos, 0);
            $res3 = $db->select('upload_id', $_GET['src']); // all photo instances
            $sorter = $db->select('album_id', $_GET['target']);
            //$db->sort_by_column($sorter, 'sort_order', 1);
            $sorter = $db->order_by($sorter, 'sort_order', 1);
            $db->close();

            $verify = true;
            foreach ($res3 as $value) {
                if ($value['album_id'] == $_GET['target']) {
                    $verify = false;
                }
            }


            echo '<h2>List Uploads</h2>';
            echo $tool_menu;

            //echo '<p><img src="../ipap-photos/'.$res[0]['filename'].'" /></p>';


            if (!$verify) {
                echo 'The photo <strong>'.$res[0]['filename'].'</strong> is already in this album.';
            } else {
                if ( isset($_GET['target']) && isset($_GET['src']) ) {

                    // write to album
                    $db->open('../'.$path_db.$db_photos, 1);

                    $new['id'] = $db->new_id();
                    $new['upload_id'] = $_GET['src'];
                    $new['album_id'] = $_GET['target'];
                    $new['sort_order'] = $sorter[0]['sort_order'] + 10;
                    $new['title'] = $res[0]['filename'];
                    $new['caption'] = '';
                    $new['location'] = '';

                    require_once '../'.$path_lib.'class.exif.php';
                    $exif = new ipap_exif('../'.$path_photos.$res[0]['filename']);
                    $exif->process_file();
                    if ( strlen($exif->get_exif_date()) > 0 ) {
                        //$new['date_taken'] = date('Y-m-d H:i:s', strtotime($exif->get_exif_date()));
                        $new['date_taken'] = reformat_exif_date($exif->get_exif_date());
                    } else {
                        $new['date_taken'] = date('Y-m-d H:i:s', filemtime('../'.$path_photos.$res[0]['filename']) + (3600*$server_time_offset));
                        //$new['date_taken'] = '';
                    }

                    $new['visible'] = '1';
                    $new['date_created'] = date('Y-m-d H:i:s', time() + (3600*$server_time_offset));
                    $new['date_edited'] = date('Y-m-d H:i:s', time() + (3600*$server_time_offset));


                    $db->insert($new);
                    $db->close();




                    // modify last edit time of album
                    set_edit_time($_GET['target']);

                    echo 'The photo <strong>'.$res[0]['filename'].'</strong> has been copied to the <strong>'.$res2[0]['title'].'</strong> album.';

                }
            }


        echo '<p><a href="'.$self.'?op=tools-list-uploads">Back to <strong>List Uploads</strong></a>.</p>';

        }

        break;
    }









    default : { //! list-albums
    // 2004-04-29 23:20:37

        $db->open('../'.$path_db.$db_albums, 0);

        $res = $db->get_all();
        $res = $db->order_by($res, 'sort_order', 'DESC');


        if (count($res) != 0) {

            echo '<h2>Current albums</h2>';
            
            echo '<form enctype="multipart/form-data" method="post" action="'.$self.'?op=edit-album-sort">';
            
            echo '<p><strong>reset cover</strong> - Use default cover, as dictated by the sort order.<br />
            <strong>sort_order</strong> - Used for display sequence of photo albums.
                    Reversed sort (highest first) for albums.<br />
                        <strong>visible</strong> - Uncheck this to hide an album.<br />
                        <strong>upload</strong> - Add (upload) photos to the given album.<br />
                        <strong>edit</strong> - Edit the album and its contents.<br />
                        <strong>delete</strong> - Delete the album.
                    </p>';

            echo '<table>
            <tr>
                <th>Info</th>
                <th>Sort Order</th>
                <th>Visible?</th>
                <th>Cover Image ID</th>
                <th>Options</th>
            </tr>
            ';

            foreach ($res as $value) {

                if ($value['visible'] == 1) {
                    $checked = 'checked="checked"';
                } else {
                    $checked = '';
                }

                $c_img = '';
                if ('' != $value['cover_image']) {
                    $c_img =  $value['cover_image'].'<br />';
                }

                echo '<tr>
                    <td>Title: <strong>'.wptexturize($value['title']).'</strong><br />
                        <span class="info">Last changed: '.date($gallery_date_format, strtotime($value['date_edited'])).'</span>
                    </td>

                    <td><input type="text" id="sort_'.$value['id'].'" name="sort_'.$value['id'].'" size="4" value="'.$value['sort_order'].'" /></td>

                    <td><input type="checkbox" id="visible_'.$value['id'].'" name="visible_'.$value['id'].'" '.$checked.' /></td>

                    <td>'.$c_img.'<a href="'.$self.'?op=reset-cover-photo&amp;id='.$value['id'].'">reset cover</a></td>

                    <td><a href="'.$self.'?op=upload-to-album&amp;album_id='.$value['id'].'" title="Upload photos to this album.">upload</a> .
                        <a href="'.$self.'?op=edit-album&amp;id='.$value['id'].'" title="Edit this album&#8217;s details and contents.">edit</a> .
                        <a href="'.$self.'?op=delete-album&amp;id='.$value['id'].'" title="Delete this album.">delete</a>
                        </td>
                </tr>';

            }

            echo '</table>';
            echo '<p><input class="mysubmit" type="submit" name="Submit" value="Save changes to sort &amp; visibility" /></p>';
            echo '</form>';

        } else {
            echo 'No albums yet.';
        }

    ?>

    <h2>Add new album</h2>
    <form name="form1" enctype="multipart/form-data" method="post" action="<?php echo $self; ?>?op=make-album">
    <input name="makecheck" type="hidden" />

    <p class="formtype"><label for="album">Album title:</label><br /><input type="text" id="album" name="album" size="32"  /><p><input class="mysubmit" type="submit" name="Submit" value="Make new album" /></p>
    </form>

    </div>


    <?php

        break;
    } // end list-albums





} // end switch







$end = microtime();
echo '<p id="footer">'.$ipap_version.' | Page generated in '.microtime_diff($end, $start).' seconds. ';
echo $html_footer;

?>